
/**
 * Magic Square Class
 */
public class MagicSquare
{
    
    private int d;
    private int square[][];
    
    /**
     * Creates magic square with given dimension.
     * Note: only odd dimentions are supported
     * @param dimension dimension of magic square
     */
    public MagicSquare(int dimension)
    {
        d = dimension;
        square = new int[d][d];
        
        int x = 0,  y = 0;  // coordinates
        int n = 1;          // current number
        
        for (int i = 0; i < d; i++) {
            for (int j = 0; j < d; j++) {
                x = (d - 1)/2 - i + j;
                y = -(d - 1)/2 + i + j;
                square[wrap(x)][wrap(y)] = n++;
            }
        }
    }
    
    /**
     * Returns dimension of magic square.
     * @return dimension
     */
    public int getDimension() {
        return d;
    }
    
    /**
     * Returns magic square as array.
     * @return array
     */
    public int[][] getSquareAsArray() {
        return square;
    }
        
    private int wrap(int x) {
        if (x < 0) {
            return x + d;
        } else if (x >= d) {
            return x - d;
        } else {
            return x;
        }
    }    
}