/*
                 1
              6     2
          11     7     3                11 24  7 20  3
       16    12     8     4              4 12 25  8 16
    21    17    13     9     5   -->    17  5 13 21  9
       22    18    14    10             10 18  1 14 22
          23    19    15                23  6 19  2 15
             24    20
                25
*/

class MagicSquare {

    public static final int dim = 5;  /* Dimension of matrix */
    public static double[][] a = new double[dim][dim];
    public static double[][] res = new double[dim][dim];
    public static int iter;

    public static void main (String args[]) {
        for (int ipr = 0; ipr < 5; ipr++) {
            long start = System.currentTimeMillis();
            iter = 100000;

            res = test(a);

            long end = System.currentTimeMillis();
            System.out.println("Total time = "+ (end-start)*0.001);

            for (int i = 0; i < dim; i++) {
                for (int j = 0; j < dim; j++) {
                    System.out.print(res[i][j] + " " );
                }
                System.out.println(" ");
            };
        System.out.println(" " );
        } 
    }

/*
    public static double[][] test(double[][] a) {
        double[][] magic = new double[dim][dim];
        double[] rr = new double[dim];
        double[] rr1 = new double[dim];
        
        int x = (dim - 1)/2 + (dim + 1);
        int y = -(dim - 1)/2 + (dim - 1);

        double summa = dim * (dim*dim + 1) /2;
        int n = 1;
        
        for (int i = 0; i < dim; i++) {
            x = x - (dim + 1);
            y = y - (dim - 1);
            for (int j = 0; j < dim; j++) {
                if (x >= dim) magic[x-dim][y] = n/summa;
                  else if (x <  0  ) magic[x+dim][y] = n/summa;
                    else if (y >= dim) magic[x][y-dim] = n/summa;
                      else if (y <  0  ) magic[x][y+dim] = n/summa;
                        else magic[x][y] = n/summa;
                n++;
                x++;
                y++;
            }
        }

        for (int i = 0; i < dim; i++) {
            for (int k = 0; k < dim; k++) rr[k] = magic[i][k];
            for (int iiii = 0; iiii < iter; iiii++) {
                for (int j = 0; j < dim; j++) {
                    rr1[j] = 0.0;
                    for (int k = 0; k < dim; k++) {
                        rr1[j] = rr1[j] + rr[k]*magic[k][j];
                    }
                }
                for (int k = 0; k < dim; k++) rr[k] = rr1[k];
            }
            for (int k = 0; k < dim; k++) res[i][k] = rr[k];
        }
        return res;    
    }
*/
//--------------------------------------   3 sec - postprocessing...
	public static double[][] test (final double[][] a_2)
	{
	  final double[] rr_9 = new double[5];
	  rr_9[0] = 0.16923076923076924D;
	  rr_9[1] = 0.06153846153846154D;
	  rr_9[2] = 0.26153846153846155D;
	  rr_9[3] = 0.15384615384615385D;
	  rr_9[4] = 0.35384615384615387D;
	  for (int iiii_490 = 0; iiii_490 < MagicSquare.iter; iiii_490++) {
	    final double rr1_1_572 = rr_9[0] * 0.06153846153846154D + rr_9[1] * 0.18461538461538463D + rr_9[2] * 0.38461538461538464D + rr_9[3] * 0.12307692307692308D + rr_9[4] * 0.24615384615384617D;
	    final double rr1_2_617 = rr_9[0] * 0.26153846153846155D + rr_9[1] * 0.07692307692307693D + rr_9[2] * 0.2D + rr_9[3] * 0.3230769230769231D + rr_9[4] * 0.13846153846153847D;
	    final double rr1_3_662 = rr_9[0] * 0.15384615384615385D + rr_9[1] * 0.27692307692307694D + rr_9[2] * 0.015384615384615385D + rr_9[3] * 0.2153846153846154D + rr_9[4] * 0.3384615384615385D;
	    final double rr1_4_707 = rr_9[0] * 0.35384615384615387D + rr_9[1] * 0.09230769230769231D + rr_9[2] * 0.2923076923076923D + rr_9[3] * 0.03076923076923077D + rr_9[4] * 0.23076923076923078D;
	    rr_9[0] = rr_9[0] * 0.16923076923076924D + rr_9[1] * 0.36923076923076925D + rr_9[2] * 0.1076923076923077D + rr_9[3] * 0.3076923076923077D + rr_9[4] * 0.046153846153846156D;
	    rr_9[1] = rr1_1_572;
	    rr_9[2] = rr1_2_617;
	    rr_9[3] = rr1_3_662;
	    rr_9[4] = rr1_4_707;
	    continue;}
	  /*for*/
	  MagicSquare.res[0][0] = rr_9[0];
	  MagicSquare.res[0][1] = rr_9[1];
	  MagicSquare.res[0][2] = rr_9[2];
	  MagicSquare.res[0][3] = rr_9[3];
	  MagicSquare.res[0][4] = rr_9[4];
	  rr_9[0] = 0.36923076923076925D;
	  rr_9[1] = 0.18461538461538463D;
	  rr_9[2] = 0.07692307692307693D;
	  rr_9[3] = 0.27692307692307694D;
	  rr_9[4] = 0.09230769230769231D;
	  for (int iiii_1034 = 0; iiii_1034 < MagicSquare.iter; iiii_1034++) {
	    final double rr1_1_1116 = rr_9[0] * 0.06153846153846154D + rr_9[1] * 0.18461538461538463D + rr_9[2] * 0.38461538461538464D + rr_9[3] * 0.12307692307692308D + rr_9[4] * 0.24615384615384617D;
	    final double rr1_2_1161 = rr_9[0] * 0.26153846153846155D + rr_9[1] * 0.07692307692307693D + rr_9[2] * 0.2D + rr_9[3] * 0.3230769230769231D + rr_9[4] * 0.13846153846153847D;
	    final double rr1_3_1206 = rr_9[0] * 0.15384615384615385D + rr_9[1] * 0.27692307692307694D + rr_9[2] * 0.015384615384615385D + rr_9[3] * 0.2153846153846154D + rr_9[4] * 0.3384615384615385D;
	    final double rr1_4_1251 = rr_9[0] * 0.35384615384615387D + rr_9[1] * 0.09230769230769231D + rr_9[2] * 0.2923076923076923D + rr_9[3] * 0.03076923076923077D + rr_9[4] * 0.23076923076923078D;
	    rr_9[0] = rr_9[0] * 0.16923076923076924D + rr_9[1] * 0.36923076923076925D + rr_9[2] * 0.1076923076923077D + rr_9[3] * 0.3076923076923077D + rr_9[4] * 0.046153846153846156D;
	    rr_9[1] = rr1_1_1116;
	    rr_9[2] = rr1_2_1161;
	    rr_9[3] = rr1_3_1206;
	    rr_9[4] = rr1_4_1251;
	    continue;}
	  /*for*/
	  MagicSquare.res[1][0] = rr_9[0];
	  MagicSquare.res[1][1] = rr_9[1];
	  MagicSquare.res[1][2] = rr_9[2];
	  MagicSquare.res[1][3] = rr_9[3];
	  MagicSquare.res[1][4] = rr_9[4];
	  rr_9[0] = 0.1076923076923077D;
	  rr_9[1] = 0.38461538461538464D;
	  rr_9[2] = 0.2D;
	  rr_9[3] = 0.015384615384615385D;
	  rr_9[4] = 0.2923076923076923D;
	  for (int iiii_1578 = 0; iiii_1578 < MagicSquare.iter; iiii_1578++) {
	    final double rr1_1_1660 = rr_9[0] * 0.06153846153846154D + rr_9[1] * 0.18461538461538463D + rr_9[2] * 0.38461538461538464D + rr_9[3] * 0.12307692307692308D + rr_9[4] * 0.24615384615384617D;
	    final double rr1_2_1705 = rr_9[0] * 0.26153846153846155D + rr_9[1] * 0.07692307692307693D + rr_9[2] * 0.2D + rr_9[3] * 0.3230769230769231D + rr_9[4] * 0.13846153846153847D;
	    final double rr1_3_1750 = rr_9[0] * 0.15384615384615385D + rr_9[1] * 0.27692307692307694D + rr_9[2] * 0.015384615384615385D + rr_9[3] * 0.2153846153846154D + rr_9[4] * 0.3384615384615385D;
	    final double rr1_4_1795 = rr_9[0] * 0.35384615384615387D + rr_9[1] * 0.09230769230769231D + rr_9[2] * 0.2923076923076923D + rr_9[3] * 0.03076923076923077D + rr_9[4] * 0.23076923076923078D;
	    rr_9[0] = rr_9[0] * 0.16923076923076924D + rr_9[1] * 0.36923076923076925D + rr_9[2] * 0.1076923076923077D + rr_9[3] * 0.3076923076923077D + rr_9[4] * 0.046153846153846156D;
	    rr_9[1] = rr1_1_1660;
	    rr_9[2] = rr1_2_1705;
	    rr_9[3] = rr1_3_1750;
	    rr_9[4] = rr1_4_1795;
	    continue;}
	  /*for*/
	  MagicSquare.res[2][0] = rr_9[0];
	  MagicSquare.res[2][1] = rr_9[1];
	  MagicSquare.res[2][2] = rr_9[2];
	  MagicSquare.res[2][3] = rr_9[3];
	  MagicSquare.res[2][4] = rr_9[4];
	  rr_9[0] = 0.3076923076923077D;
	  rr_9[1] = 0.12307692307692308D;
	  rr_9[2] = 0.3230769230769231D;
	  rr_9[3] = 0.2153846153846154D;
	  rr_9[4] = 0.03076923076923077D;
	  for (int iiii_2122 = 0; iiii_2122 < MagicSquare.iter; iiii_2122++) {
	    final double rr1_1_2204 = rr_9[0] * 0.06153846153846154D + rr_9[1] * 0.18461538461538463D + rr_9[2] * 0.38461538461538464D + rr_9[3] * 0.12307692307692308D + rr_9[4] * 0.24615384615384617D;
	    final double rr1_2_2249 = rr_9[0] * 0.26153846153846155D + rr_9[1] * 0.07692307692307693D + rr_9[2] * 0.2D + rr_9[3] * 0.3230769230769231D + rr_9[4] * 0.13846153846153847D;
	    final double rr1_3_2294 = rr_9[0] * 0.15384615384615385D + rr_9[1] * 0.27692307692307694D + rr_9[2] * 0.015384615384615385D + rr_9[3] * 0.2153846153846154D + rr_9[4] * 0.3384615384615385D;
	    final double rr1_4_2339 = rr_9[0] * 0.35384615384615387D + rr_9[1] * 0.09230769230769231D + rr_9[2] * 0.2923076923076923D + rr_9[3] * 0.03076923076923077D + rr_9[4] * 0.23076923076923078D;
	    rr_9[0] = rr_9[0] * 0.16923076923076924D + rr_9[1] * 0.36923076923076925D + rr_9[2] * 0.1076923076923077D + rr_9[3] * 0.3076923076923077D + rr_9[4] * 0.046153846153846156D;
	    rr_9[1] = rr1_1_2204;
	    rr_9[2] = rr1_2_2249;
	    rr_9[3] = rr1_3_2294;
	    rr_9[4] = rr1_4_2339;
	    continue;}
	  /*for*/
	  MagicSquare.res[3][0] = rr_9[0];
	  MagicSquare.res[3][1] = rr_9[1];
	  MagicSquare.res[3][2] = rr_9[2];
	  MagicSquare.res[3][3] = rr_9[3];
	  MagicSquare.res[3][4] = rr_9[4];
	  rr_9[0] = 0.046153846153846156D;
	  rr_9[1] = 0.24615384615384617D;
	  rr_9[2] = 0.13846153846153847D;
	  rr_9[3] = 0.3384615384615385D;
	  rr_9[4] = 0.23076923076923078D;
	  for (int iiii_2666 = 0; iiii_2666 < MagicSquare.iter; iiii_2666++) {
	    final double rr1_1_2748 = rr_9[0] * 0.06153846153846154D + rr_9[1] * 0.18461538461538463D + rr_9[2] * 0.38461538461538464D + rr_9[3] * 0.12307692307692308D + rr_9[4] * 0.24615384615384617D;
	    final double rr1_2_2793 = rr_9[0] * 0.26153846153846155D + rr_9[1] * 0.07692307692307693D + rr_9[2] * 0.2D + rr_9[3] * 0.3230769230769231D + rr_9[4] * 0.13846153846153847D;
	    final double rr1_3_2838 = rr_9[0] * 0.15384615384615385D + rr_9[1] * 0.27692307692307694D + rr_9[2] * 0.015384615384615385D + rr_9[3] * 0.2153846153846154D + rr_9[4] * 0.3384615384615385D;
	    final double rr1_4_2883 = rr_9[0] * 0.35384615384615387D + rr_9[1] * 0.09230769230769231D + rr_9[2] * 0.2923076923076923D + rr_9[3] * 0.03076923076923077D + rr_9[4] * 0.23076923076923078D;
	    rr_9[0] = rr_9[0] * 0.16923076923076924D + rr_9[1] * 0.36923076923076925D + rr_9[2] * 0.1076923076923077D + rr_9[3] * 0.3076923076923077D + rr_9[4] * 0.046153846153846156D;
	    rr_9[1] = rr1_1_2748;
	    rr_9[2] = rr1_2_2793;
	    rr_9[3] = rr1_3_2838;
	    rr_9[4] = rr1_4_2883;
	    continue;}
	  /*for*/
	  MagicSquare.res[4][0] = rr_9[0];
	  MagicSquare.res[4][1] = rr_9[1];
	  MagicSquare.res[4][2] = rr_9[2];
	  MagicSquare.res[4][3] = rr_9[3];
	  MagicSquare.res[4][4] = rr_9[4];
	  return MagicSquare.res;
	}
//--------------------------------------  11 sec - JScp version 0.0.75


}